//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
#include "jpeg.hpp"

TMemoryStream *ms1;
TJPEGImage *jpg;
TStringList *sl;
int iIndex=0;
AnsiString szClientIP;

#define CLIENT_PORT 4000
#define SERVER_PORT 5000
#define COMMAND_LEN 32
#define DATA_LEN 2048

typedef struct _MYPACKET1
{
   char szCommand[COMMAND_LEN];
   int iIndex;
   int iTotal;
} MYPACKET1, *PMYPACKET1;

typedef struct _MYPACKET2
{
   char szCommand[COMMAND_LEN];
   int iIndex;
   BYTE bData[DATA_LEN];
   int iLen;
} MYPACKET2, *PMYPACKET2;

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
   : TForm(Owner)
{
   Panel1->DoubleBuffered=true;
   Image1->Width=800;
   Image1->Height=600;
   Image1->Left=(Panel1->Width-Image1->Width)/2;
   Image1->Top=(Panel1->Height-Image1->Height)/2;
   Image1->Canvas->Brush->Color=clWhite;
   Image1->Canvas->FillRect(Rect(0, 0, Image1->Width, Image1->Height));
   Image1->Stretch=true;

   Timer1->Interval=1000;
   Timer1->Enabled=false;

   IdUDPServer1->DefaultPort=SERVER_PORT;
   IdUDPServer1->Active=true;

   ms1=NULL;
   jpg=NULL;
   sl=NULL;
}
__fastcall TForm1::~TForm1()
{
   Timer1->Enabled=false;
   IdUDPServer1->Active=false;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::IdUDPServer1UDPRead(TObject *Sender,
      TStream *AData, TIdSocketHandle *ABinding)
{
   MYPACKET1 MyPacket1;
   MYPACKET2 MyPacket2;

   AnsiString szCommand;
   szCommand.SetLength(COMMAND_LEN);
   AData->Position=0;
   AData->Read(&szCommand[1], COMMAND_LEN);

   AData->Position=0;
   if(szCommand.SubString(1, 20)=="ClientToServer-Start")
   {
      AData->Read(&MyPacket1, sizeof(MYPACKET1));

      if(ms1!=NULL)
      {
         delete ms1;
         ms1=NULL;
      }
      ms1=new TMemoryStream;
      ms1->Size=MyPacket1.iTotal;
      ms1->Position=0;
      if(jpg!=NULL)
      {
         delete jpg;
         jpg=NULL;
      }
      jpg=new TJPEGImage;
      if(sl!=NULL)
      {
         delete sl;
         sl=NULL;
      }
      sl=new TStringList;
      for(int i=0; i<MyPacket1.iIndex; i++)
      {
         sl->Add("0");
      }
      iIndex=0;
   }
   else if(szCommand.SubString(1, 19)=="ClientToServer-Stop")
   {
      AData->Read(&MyPacket1, sizeof(MYPACKET1));
      if(ms1!=NULL)
      {
         ms1->Position=0;
      }
      if(jpg!=NULL)
      {
         bool bError=false;
         for(int i=0; i<MyPacket1.iIndex; i++)
         {
            if(sl->Strings[i]=="0")
            {
               bError=true;
               break;
            }
         }
         if(!bError)
         {
            jpg->LoadFromStream(ms1);
            jpg->CompressionQuality=100;
            Image1->Picture->Assign(jpg);
         }
      }
      if(ms1!=NULL)
      {
         delete ms1;
         ms1=NULL;
      }
      if(jpg!=NULL)
      {
         delete jpg;
         jpg=NULL;
      }
      if(sl!=NULL)
      {
         delete sl;
         sl=NULL;
      }
      iIndex=0;
   }
   else if(szCommand.SubString(1, 23)=="ClientToServer-Continue")
   {
      if(ms1!=NULL)
      {
         AData->Read(&MyPacket2, sizeof(MYPACKET2));
         ms1->Position=MyPacket2.iIndex*DATA_LEN;
         ms1->Write(MyPacket2.bData, MyPacket2.iLen);
         sl->Strings[MyPacket2.iIndex]="1";
      }
      iIndex++;
   }
   else if(szCommand.SubString(1, 20)=="ClientToServer-Clean")
   {
      Image1->Picture=NULL;
      Image1->Canvas->Brush->Color=clWhite;
      Image1->Canvas->FillRect(Rect(0, 0, Image1->Width, Image1->Height));
   }
   else if(szCommand.SubString(1, 20)=="ServerToClient-Start")
   {
      szClientIP=ABinding->PeerIP;
      Timer1->Enabled=true;
   }
   else if(szCommand.SubString(1, 19)=="ServerToClient-Stop")
   {
      Timer1->Enabled=false;
   }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Timer1Timer(TObject *Sender)
{
   Graphics::TBitmap *bmp1=new Graphics::TBitmap;
   TMemoryStream *ms1=new TMemoryStream;
   try
   {
      HDC dc;
      TCanvas *cs=new TCanvas;

      dc=GetDC(0);
      cs->Handle=dc;
      bmp1->Width=Screen->Width;
      bmp1->Height=Screen->Height;
      bmp1->Canvas->CopyRect(Rect(0, 0, bmp1->Width, bmp1->Height), cs,
         Rect(0, 0, Screen->Width, Screen->Height));

      POINT pt;
      HCURSOR hCur=GetCursor();
      GetCursorPos(&pt);
      DrawIcon(bmp1->Canvas->Handle, pt.x, pt.y, hCur);

      TJPEGImage *jpg=new TJPEGImage;
      jpg->Assign(bmp1);
      jpg->CompressionQuality=20;
      jpg->Compress();
      jpg->SaveToStream(ms1);

      delete jpg;
      delete cs;
      ReleaseDC(NULL, dc);

      int iTotal=ms1->Size;
      int iPacket=DATA_LEN;
      int iTime=(iTotal%iPacket==0)? iTotal/iPacket: iTotal/iPacket+1;

      MYPACKET1 MyPacket1;
      ZeroMemory(&MyPacket1, sizeof(MYPACKET1));
      lstrcpy(MyPacket1.szCommand, "ServerToClient-Start");
      MyPacket1.iIndex=iTime;
      MyPacket1.iTotal=iTotal;
      IdUDPServer1->SendBuffer(szClientIP, CLIENT_PORT, &MyPacket1, sizeof(MYPACKET1));
      IdUDPServer1->SendBuffer(szClientIP, CLIENT_PORT, &MyPacket1, sizeof(MYPACKET1));

      for(int i=0; i<iTime; i++)
      {
         ms1->Position=i*iPacket;
         int iLen1=(i<iTime-1)? iPacket: iTotal-i*iPacket;
         MYPACKET2 MyPacket2;
         ZeroMemory(&MyPacket2, sizeof(MYPACKET2));
         lstrcpy(MyPacket2.szCommand, "ServerToClient-Continue");
         MyPacket2.iIndex=i;
         ms1->Read(MyPacket2.bData, iLen1);
         MyPacket2.iLen=iLen1;

         Sleep(10);
         IdUDPServer1->SendBuffer(szClientIP, CLIENT_PORT, &MyPacket2, sizeof(MYPACKET2));
         Sleep(10);
      }
      ZeroMemory(&MyPacket1, sizeof(MYPACKET1));
      lstrcpy(MyPacket1.szCommand, "ServerToClient-Stop");
      MyPacket1.iIndex=iTime;
      MyPacket1.iTotal=iTotal;
      IdUDPServer1->SendBuffer(szClientIP, CLIENT_PORT, &MyPacket1, sizeof(MYPACKET1));
      IdUDPServer1->SendBuffer(szClientIP, CLIENT_PORT, &MyPacket1, sizeof(MYPACKET1));
   }
   __finally
   {
      delete ms1;
      delete bmp1;
   }
}
//---------------------------------------------------------------------------

